﻿using System;
using System.Collections;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Controls.Scheduling;

namespace GanttCustomizations
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			var start = DateTime.Today;
			var tasks = new ObservableCollection<CustomTask>
			{
				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },

				new CustomTask { Title = "R", Start = start, End = start.AddDays(1), Background = Brushes.Red },
				new CustomTask { Title = "G", Start = start.AddDays(2), End = start.AddDays(3), Background = Brushes.Green },
				new CustomTask { Title = "B", Start = start.AddDays(1), End = start.AddDays(6), Background = Brushes.Blue },
			};
			this.DataContext = new ViewModel { Tasks = tasks, VisibleRange = new DateRange(start, start.AddDays(7)) };
		}

		public class ViewModel : ViewModelBase
		{
			private IDateRange visibleRange;

			/// <Summary>Gets or sets VisibleRange and notifies for changes</Summary>
			public IDateRange VisibleRange
			{
				get { return this.visibleRange; }
				set
				{
					if (this.visibleRange != value)
					{
						this.visibleRange = value;
						this.OnPropertyChanged(() => this.VisibleRange);
					}
				}
			}

			private IEnumerable tasks;

			/// <Summary>Gets or sets Tasks and notifies for changes</Summary>
			public IEnumerable Tasks
			{
				get { return this.tasks; }
				set
				{
					if (this.tasks != value)
					{
						this.tasks = value;
						this.OnPropertyChanged(() => this.Tasks);
					}
				}
			}
		}

		public class CustomTask : GanttTask
		{
			private Brush background;

			/// <Summary>Gets or sets Background and notifies for changes</Summary>
			public Brush Background
			{
				get { return this.background; }
				set
				{
					if (this.background != value)
					{
						this.background = value;
						this.OnPropertyChanged(() => this.Background);
					}
				}
			}
		}
	}
}
